void ClrScr(void)
{
/*
this function clears the screen
*/
unsigned char cur_pix;
/*END OF DECLARATIONS*/
	for(cur_pix=0;cur_pix<=NR_PIXELI;cur_pix++)
	{
#if NR_PIXELI<=84
		ldimage1[cur_pix]=0;
#else
		if(cur_pix<=95)
			ldimage1[cur_pix]=0;
		else
			ldimage2[cur_pix-96]=0;
#endif
	}
}
void simple_effect(void)
{
/*
this function displays data in three ways, depending of EFCONFIG
low nible value:
1. simple appearance of text
2. rising of the entire text
3. falling of the entire text
*/
unsigned char temp1;
unsigned int adrtmp;
/******END OF DECLARATIONS********************/
	if((EFCONFIG&0x0f)==NOEF)
	{
		if(steps==0)
			build_image();
		steps++;
		if(steps>=150)
		{
			EFCONFIG&=0xf0;
			nextcar++;
		}
	}
/**************************/
	if((EFCONFIG&0x0f)==BOTR || (EFCONFIG&0x0f)==TOPR)
	{
		if(steps==0)
		{
			mask=0;
			adrtmp=nextcar; // back-up of the address of the next char
		}
		if(steps<=32 && !(steps&0x03))
		{
			nextcar=adrtmp; // restrore the address of the next char
			build_image();
			for(temp1=0;temp1<=NR_PIXELI;temp1++)
			{
				if(temp1<=95)
					ldimage1[temp1]=ldimage1[temp1]&mask;
#if NR_PIXELI>84
				if(temp1>95)
					ldimage2[temp1-96]=ldimage2[temp1-96]&mask;
#endif
			}
			if((EFCONFIG&0x0f)==BOTR)
			{	mask=mask<<1; mask|=0X1; 	}
			else
			{	mask=mask>>1; mask|=0x80; 	}
		}
		steps++;
		if(steps==150)
		{
			EFCONFIG&=0xf0;
			nextcar++;
		}
	}
/***************************/
}
/*********FALLCHAR****************/
void fallchar(void)
{
/*
this function displays the message by
falling each character, one by one
it's nice
*/
unsigned char cbuff; // one char buffer
unsigned char temp1;
/************END OF DECLARATIONS**********/
	if(steps==0) // read a new char?
	{
		cbuff=*nextcar;
		if(cbuff==0 || cbuff>127) // is EOS or E2PROM enpty
		{

			torepeat=50;
			while (torepeat)
			{
				if(bit_test(STARE,EFFECT))
				{
					torepeat--;
					bit_clear(STARE,EFFECT);
				}
			};
			EFCONFIG&=0xf0;
			nextcar++;
			return;
		}
	}
	if(!movedcars)
		ClrScr();
#if NR_PIXELI<=90
		ldimage1[movedcars+5]=0;
		for(temp1=0;temp1<5;temp1++)
		{
			ldimage1[temp1+movedcars]=char_map[cbuff-0x20][temp1]<<(8-steps);
		}
#else

		for(temp1=0;temp1<5;temp1++)
		{
			if(movedcars<=90)
			{
				ldimage1[movedcars+5]=0;
				ldimage1[temp1+movedcars]=char_map[cbuff-0x20][temp1]<<(7-steps);
			}
			else
			{
				ldimage2[movedcars-96+5]=0;
				ldimage2[temp1+movedcars-96]=char_map[cbuff-0x20][temp1]<<(7-steps);
			}
		}
#endif
	steps++;
	if(steps>=8)
	{
		steps=0;
		nextcar++;
		movedcars+=6;
	}
}
/***********RLFLOW*********************/
void rlflow(void)
{
/*
thif function dissplay a message by flowing it
from right to left.
The message can exceed 20 characters
*/
unsigned char cbuff; // one char buffer
unsigned char temp1;
#define temp2	cbuff
/************END OF DECLARATIONS**********/
	if(steps==0) // read a new char?
	{
		cbuff=*nextcar;
		if(cbuff==0 || cbuff>127) // is EOS or E2PROM empty
		{
			cbuff=' ';
			torepeat--;
			if(torepeat==0)
			{
				EFCONFIG&=0xf0; // finish
				nextcar++;
				return;
			}
		}
		else
		{
			torepeat=NR_CARS+1;
			nextcar++;
		}
#if NR_PIXELI<=90
		ldimage1[NR_PIXELI]=0;
		for(temp1=0;temp1<5;temp1++)
		{
			ldimage1[temp1+NR_PIXELI]=char_map[cbuff-0x20][temp1];
		}
#else
		ldimage2[NR_PIXELI-96]=0;
		for(temp1=0;temp1<5;temp1++)
		{
			ldimage2[temp1+NR_PIXELI-96]=char_map[cbuff-0x20][temp1];
		}
#endif
	}
	/**one pixel moving**/
	for(temp1=0;temp1<=(NR_PIXELI+6);temp1++)
	{
		if(temp1<95)
			ldimage1[temp1]=ldimage1[temp1+1];
#if NR_PIXELI>84
		if(temp1==95)
		{
			ldimage1[95]=ldimage2[0];
		}
		if(temp1>95)
			ldimage2[temp1-96]=ldimage2[temp1-95];
#endif
	}
	steps++;
	if(steps==6)
		steps=0;
}

void rlchars(void)
{
/*
this function flows each character of a message from right to left
*/
 unsigned char cbuff; // one char buffer
unsigned char temp1;
/************END OF DECLARATIONS**********/
	if(steps==0) // read a new char?
	{
		cbuff=*nextcar;
		if(cbuff==0 || cbuff>127) // is EOS or E2PROM empty?
		{
			torepeat=50;
			while (torepeat)
			{
				if(bit_test(STARE,EFFECT))
				{
					torepeat--;
					bit_clear(STARE,EFFECT);
				}
			};
			EFCONFIG&=0xf0; // end of the effect
			nextcar++;
			return;
		}
		if(cbuff==' ' && movedcars!=0)
		{
			goto NextCar;
		}
/*take a new char and put it in the queue*/
#if NR_PIXELI<=90
		ldimage1[NR_PIXELI]=0;
		for(temp1=0;temp1<5;temp1++)
		{
			ldimage1[temp1+NR_PIXELI]=char_map[cbuff-0x20][temp1];
		}
#else
		ldimage2[NR_PIXELI-96]=0;
		for(temp1=0;temp1<5;temp1++)
		{
			ldimage2[temp1+NR_PIXELI-96]=char_map[cbuff-0x20][temp1];
		}
#endif
	}
/******one pixel moving*************/
	for(temp1=movedcars;temp1<=(NR_PIXELI+5);temp1++)
	{
		if(temp1<94)
			ldimage1[temp1]=ldimage1[temp1+2];
#if NR_PIXELI>84
		if(temp1==94)
		{
			ldimage1[94]=ldimage2[0];
		}
		if(temp1==95)
		{
			ldimage1[95]=ldimage2[1];
		}
		if(temp1>95)
			ldimage2[temp1-96]=ldimage2[temp1-94];
#endif
	}
/***********************************************/
	steps++;
	if(steps==((NR_PIXELI-movedcars)/2))
	{
		steps=0;
NextCar:
		nextcar++;
		if(movedcars<NR_PIXELI)
			movedcars+=6;
	}
}



